<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="search.keyWord" placeholder="关键字" style="width: 200px;" class="filter-item" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="searchData">
        搜索
      </el-button>
      <el-button
        class="filter-item"
        style="margin-left: 10px;"
        type="primary"
        icon="el-icon-plus"
        @click="handleCreateAdd">
        增加产品分类档案
      </el-button>
    </div>
    <el-table
      :data="tableData"
      v-loading="listLoading"
      row-key="id"
      border
      default-expand-all>
      <el-table-column
        type="index">
      </el-table-column>
      <el-table-column
        prop="productTypeName"
        label="产品分类名称">
      </el-table-column>
      </el-table-column>
      <el-table-column align="center" label="状态" class-name="status-col" width="100">
        <template slot-scope="{row}">
          <el-tag v-if="row.voidFlag==0" type="success">
            启用
          </el-tag>
          <el-tag v-else="row.voidFlag==1" type="danger">
            禁用
          </el-tag>
        </template>
      </el-table-column>
      <el-table-column label="操作" fixed="left" align="center" width="230" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          <el-button @click="handleUpdate(row)" type="primary" size="mini">
            编辑
          </el-button>
          <el-button @click="editStatus(row.id,'1')" type="danger" v-if="row.voidFlag==0" size="mini">
            禁用
          </el-button>
          <el-button @click="editStatus(row.id,'0')" v-else="row.voidFlag==1" size="mini">
            启用
          </el-button>


        </template>
      </el-table-column>

    </el-table>
    <pagination v-show="listData.total>0" :total="listData.total" :page.sync="listData.page" :limit.sync="listData.pageSize" @pagination="getProductTypeInfo" />


    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible">
      <el-form label-width="130px" label-position="right">
        <el-form-item label="分类名称">
          <el-input v-model="form.productTypeName"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="dialogStatus==='1'?addBtn():editBtn()">确 定</el-button>
      </div>
    </el-dialog>
<!--    <servicedialog @tableRefresh="tableRefresh" ref="menuDialog" :dialogStatus="dialogStatus" :menuId="menuId" :titleDialog="titleDialog" :dialogVisible="dialogVisible"/>-->
    <cancledialog @tableRefresh="tableRefresh" ref="confirmDialog"></cancledialog>
  </div>
</template>

<script>
  import {getProductTypeList,addProductType,getProductTypeInfoById,updateProductType} from '@/api/productFile/productType.js'
  import Cancledialog from '@/components/Dialog/Cancledialog.vue'

  export default {
    components: {
      Cancledialog
    },
    filters: {
      statusFilter(status) {
        const statusMap = {
          1: 'success',
          0: 'danger'
        }
        return statusMap[status]
      }
    },
    data() {
      return {
        dialogStatus: 1,//1增加，2修改
        dialogTitle: '',
        dialogVisible: false,
        search: {
          keyWord:''
        },
        form:{
          productTypeName:'',
        },
        listData:{
          total:0,
          page: 1,
          pageSize:10
        },

        options:[],

        confirmdialog:false,
        listLoading: false,
        tableData: [],
        menuId:''
      }
    },
    mounted() {
      this.getProductTypeInfo();
    },
    methods: {
      //获取列表
      getProductTypeInfo() {
        const _that = this
        _that.listLoading = true


        var params =_that.search;
        var page = {
          pageIndex:_that.listData.page,
          pageSize: _that.listData.pageSize,
        }
        var data = {
          "params": JSON.stringify(params),
          "page": JSON.stringify(page),
        }

        getProductTypeList(data).then(response => {
          console.log(response)
          const data = response.data
          // //  组合表单数据
          _that.tableData = data
          // console.log(_that.tableData)
          _that.listData.total = response.total
          _that.listLoading = false
        }).catch(err => {
          _that.$message.error(err)
          _that.listLoading = false
        })
      },
      //增加产品分类档案
      handleCreateAdd(){
        const _that = this
        _that.form={
          processName:'',
          remark:'',
        }
        _that.dialogTitle = '增加产品分类档案'
        _that.dialogStatus = '1';
        _that.dialogVisible = true;

      },
      //刷新变革
      tableRefresh(){
        //刷新变革
        this.getProductTypeInfo()
      },
      //增加产品分类档案
      addBtn(){
        const _that = this
        var printerTypeInfo =JSON.stringify(_that.form)
        var data = {
          "productType": printerTypeInfo ,
        }
        // console.log(data);
        // return

        addProductType(data).then(res => {
          // console.log(res);
          if(res.httpCode == 200){
            _that.dialogVisible = false
            _that.$message({
              message: '增加成功',
              type: 'success'
            });
            _that.tableRefresh();
          }else{
            _that.$message.error(res.msg)
          }
        }).catch(err => {
          _that.$message.error(err)
          _that.dialogVisible = true
        })
      },

      //唤起修改
      handleUpdate(row){
        const _that = this;
        _that.form={
          processName:'',
          remark:'',
        }

        _that.dialogTitle = '修改产品分类档案信息'
        _that.dialogVisible = true
        _that.dialogStatus = '2';

        var idPrint = row.id
        var data= {
          idType:idPrint
        }

        // console.log(data);
        getProductTypeInfoById(data).then(res => {
          console.log(res);
          const data = res.data

          _that.form={
            id:data.id,
            productTypeName:data.productTypeName
          }
        }).catch(err => {
          _that.$message.error(err)
        })
      },
      //修改产品分类档案
      editBtn(){
        const _that = this
        var printerTypeInfo =JSON.stringify(_that.form)
        var data = {
          "productType": printerTypeInfo ,
        }

        updateProductType(data).then(res => {
          // console.log(res);
          if(res.httpCode == 200){
            _that.dialogVisible = false
            _that.$message({
              message: '修改成功',
              type: 'success'
            });
            _that.tableRefresh();
          }else{
            _that.$message.error(res.msg)
          }
        }).catch(err => {
          _that.$message.error(err)
          _that.dialogVisible = true
        })

      },

      //启用禁用
      editStatus(id,status){
        var _that = this;
        var printerTypeInfo = {
          id:id,
          voidFlag:status
        }
        var params = {
          "productType": JSON.stringify(printerTypeInfo),
        }

        var url = '/product/voidProductType';
        _that.$refs.confirmDialog.updataClick(params, url);
      },

      //搜索
      searchData(){
        this.listData.page = 1;
        this.getProductTypeInfo()
      }
    }
  }
</script>

<style lang="scss" scoped>
  .filter-container {
    margin-bottom: 15px;
  }
</style>
